function magnet_tool_2D(indata)
global  gui_handle data ring


if (nargin == 0) | ~isstr(indata) 
    action = 'start';
else
    action = indata;
end

%MAIN ACTION SWITCH 
switch action
case 'start'   %initiallizing
   %default values
   ring{1}.type=1; ring{2}.type=0; ring{3}.type=0;
   ring{1}.N=16; ring{2}.N=24; ring{3}.N=32;
   ring{1}.k=1; ring{2}.k=1; ring{3}.k=1;
   ring{1}.r=[10,0,0,0]; ring{2}.r=[16,0,0,0]; ring{3}.r=[25,0,0,0];
   ring{1}.dist=0; ring{2}.dist=0; ring{3}.dist=0;
   ring{1}.N_phase=0; ring{2}.N_phase=0; ring{3}.N_phase=0;
   ring{1}.angle=0; ring{2}.angle=0; ring{3}.angle=0;
   ring{1}=mandhala_2D(ring{1}.type,ring{1}.r,ring{1}.N,ring{1}.k,ring{1}.dist,ring{1}.N_phase,ring{1}); %2D Geometry ring 1
   ring{2}=mandhala_2D(ring{2}.type,ring{2}.r,ring{2}.N,ring{2}.k,ring{2}.dist,ring{2}.N_phase,ring{2}); %2D Geometry ring 2
   ring{3}=mandhala_2D(ring{3}.type,ring{3}.r,ring{3}.N,ring{3}.k,ring{3}.dist,ring{3}.N_phase,ring{3}); %2D Geometry ring 3
   data.RN=1;
   MAKEgui(' ');
   mat={'NdFeB31','NdFeB35','NdFeB38','NdFeB40','NdFeB44','NdFeB45','NdFeB48','NdFeB53','SmCo20','SmCo24','SmCo27','Sm2Co26','Sm2Co28'};
   ring{1}.v=get(gui_handle.mat1,'Value');ring{2}.v=get(gui_handle.mat2,'Value');ring{3}.v=get(gui_handle.mat3,'Value');
   ring{1}=mandhala_mat(ring{1},mat{ring{1}.v});
   ring{2}=mandhala_mat(ring{2},mat{ring{2}.v});
   ring{3}=mandhala_mat(ring{3},mat{ring{3}.v});
   make_mandhala('');
   
  case 'no_rings'
    data.RN=str2num(get(gui_handle.no_rings,'string'));
    check_vis('');
    make_mandhala(''); 
  
  case 'ri1',ring{1}.r=[str2num(get(gui_handle.ri1,'String')),0,0,0];make_mandhala('');  
  case 'rc1', ring{1}.r=[0,str2num(get(gui_handle.rc1,'String')),0,0];make_mandhala('');
  case 'ro1', ring{1}.r=[0,0,str2num(get(gui_handle.ro1,'String')),0];make_mandhala('');
  case 'ms1', ring{1}.r=[0,0,0,str2num(get(gui_handle.ms1,'String'))];make_mandhala('');
  case 'ri2',ring{2}.r=[str2num(get(gui_handle.ri2,'String')),0,0,0];make_mandhala('');  
  case 'rc2', ring{2}.r=[0,str2num(get(gui_handle.rc2,'String')),0,0];make_mandhala('');
  case 'ro2', ring{2}.r=[0,0,str2num(get(gui_handle.ro2,'String')),0];make_mandhala('');
  case 'ms2', ring{2}.r=[0,0,0,str2num(get(gui_handle.ms2,'String'))];make_mandhala('');
  case 'ri3',ring{3}.r=[str2num(get(gui_handle.ri3,'String')),0,0,0];make_mandhala('');  
  case 'rc3', ring{3}.r=[0,str2num(get(gui_handle.rc3,'String')),0,0];make_mandhala('');
  case 'ro3', ring{3}.r=[0,0,str2num(get(gui_handle.ro3,'String')),0];make_mandhala('');
  case 'ms3', ring{3}.r=[0,0,0,str2num(get(gui_handle.ms3,'String'))];make_mandhala('');
    
  case  'calc'
     make_mandhala('');
  
  case 'material'
      mat={'NdFeB31','NdFeB35','NdFeB38','NdFeB40','NdFeB44','NdFeB45','NdFeB48','NdFeB53','SmCo20','SmCo24','SmCo27','Sm2Co26','Sm2Co28'};
      ring{1}.v=get(gui_handle.mat1,'Value');ring{2}.v=get(gui_handle.mat2,'Value');ring{3}.v=get(gui_handle.mat3,'Value');
      ring{1}=mandhala_mat(ring{1},mat{ring{1}.v});
      ring{2}=mandhala_mat(ring{2},mat{ring{2}.v});
      ring{3}=mandhala_mat(ring{3},mat{ring{3}.v});

  case 'load'
   [filename,dirname]=uigetfile('*.mat','Save to MAT file');
   fname=[dirname,filename];
   load(fname,'ring','data');
   check_vis('');   set_radius('');   set_GUI('');  make_mandhala(''); 

   
  case 'save'
   [filename,dirname]=uiputfile('*.mat','Save to MAT file');
   fname=[dirname,filename];
   save(fname,'ring','data');
   
  case 'saveASCII'
    switch data.RN
    case 1
       FEMM{1}=ring{1};
    case 2
        FEMM{1}=ring{1};
        FEMM{2}=ring{2};
    otherwise
        FEMM=ring;
    end
    [filename,dirname]=uiputfile('*.txt','Save to ASCII file');
    fname=[dirname,filename];
    mandhala_write_ASCII(FEMM,fname); 
    
  case 'saveFEMM'
     switch data.RN
         case 1
             FEMM{1}=ring{1};
         case 2
             FEMM{1}=ring{1};
             FEMM{2}=ring{2};
         otherwise
             FEMM=ring;
     end
     FEM_def = inputdlg({'distance inner analysing circle:','distance outer box:','size fine mesh','size middle mesh','size coarse mesh','precision:','comments'},...
         'Input FEMM',1,{num2str(0.75*ring{1}.r(1)),num2str(1.3*ring{data.RN}.r(3)),num2str(2e-2*ring{data.RN}.r(3)),num2str(7e-2*ring{data.RN}.r(3)),num2str(1e-1*ring{data.RN}.r(3)),'1e-8',' '});
     [filename,dirname]=uiputfile('*.FEM','Save to FEM file');
     fname=[dirname,filename];
     d=[str2num(FEM_def{1}),str2num(FEM_def{2})];m=[str2num(FEM_def{3}),str2num(FEM_def{4}),str2num(FEM_def{5})];
     mandhala_write_FEMM(FEMM,fname,d,m,FEM_def{6},FEM_def{7}); 

  case 'sep_win'
    sz=get(0,'ScreenSize');
    figure('Units','pixel','Position',[500 sz(4)-490 470 450],'name','Magnet tool: separate plot window');
    gui_handle.sep_win=axes; 
    make_mandhala(1);
  
  case 'bye'
    close(gcbf);
    return    

end

function make_mandhala(swtch)
   global  gui_handle data ring
   get_GUI('');
   get_radius('');
   switch data.RN   
       case 3
         ring{3}=mandhala_2D(ring{3}.type,ring{3}.r,ring{3}.N,ring{3}.k,ring{3}.dist,ring{3}.N_phase,ring{3}); %2D Geometry ring 1
         ring{3}.angle=str2num(get(gui_handle.rot3,'String'));
         ring{3}=mandhala_rot(ring{3},ring{3}.angle); %2D rotation ring 1      
       case {3,2}     
         ring{2}=mandhala_2D(ring{2}.type,ring{2}.r,ring{2}.N,ring{2}.k,ring{2}.dist,ring{2}.N_phase,ring{2}); %2D Geometry ring 2
         ring{2}.angle=str2num(get(gui_handle.rot2,'String'));
         ring{2}=mandhala_rot(ring{2},ring{2}.angle); %2D rotation ring 1
       otherwise
         ring{1}=mandhala_2D(ring{1}.type,ring{1}.r,ring{1}.N,ring{1}.k,ring{1}.dist,ring{1}.N_phase,ring{1}); %2D Geometry ring 3
         ring{1}.angle=str2num(get(gui_handle.rot1,'String'));
         ring{1}=mandhala_rot(ring{1},ring{1}.angle); %2D rotation ring 1
   end
   set_GUI('');
   set_radius('');
   %PLOT
   if swtch==1
    gui_handle.image=axes('Units','pixel','Position',[30 30 400 400]);
   else
     gui_handle.unit_button=uipanel('Units','pixel','Position',[515 45 470 465],'Backgroundcolor',[0.83,0.81,0.78]);
     gui_handle.image=axes('Units','pixel','Position',[550 80 400 400]);
   end
    plot(0,0,'ro');hold on
   x=linspace(0,2*pi,1000);
   for j=1:data.RN
     plot(ring{j}.r(1)*sin(x),ring{j}.r(1)*cos(x),'g')
     plot(ring{j}.r(2)*sin(x),ring{j}.r(2)*cos(x),'y')
     plot(ring{j}.r(3)*sin(x),ring{j}.r(3)*cos(x),'g')
     plot(ring{j}.c(:,1),ring{j}.c(:,2),'ko','Markersize',2);
     for i=1:ring{j}.N
       line([ring{j}.p(i,:,1),ring{j}.p(i,1,1)],[ring{j}.p(i,:,2),ring{j}.p(i,1,2)],'color','b');
       a=ring{j}.r(4)*.3;
       line([ring{j}.c(i,1)-a*cos(ring{j}.m(i)),ring{j}.c(i,1)+a*cos(ring{j}.m(i))],[ring{j}.c(i,2)-a*sin(ring{j}.m(i)),ring{j}.c(i,2)+a*sin(ring{j}.m(i))],'color','m')
       plot(ring{j}.c(i,1)+a*cos(ring{j}.m(i)),ring{j}.c(i,2)+a*sin(ring{j}.m(i)),'mo','Markersize',2,'MarkerFaceColor','m')
     end
   end
   hold off
   axis equal

function get_GUI(varargin)
   global  gui_handle data ring
         data.RN=str2num(get(gui_handle.no_rings,'String'));
         ring{1}.type=str2num(get(gui_handle.type1,'String'));ring{2}.type=str2num(get(gui_handle.type2,'String'));ring{3}.type=str2num(get(gui_handle.type3,'String'));
         ring{1}.k=str2num(get(gui_handle.k1,'String'));ring{2}.k=str2num(get(gui_handle.k2,'String'));ring{3}.k=str2num(get(gui_handle.k3,'String'));
         ring{1}.N=str2num(get(gui_handle.n1,'String'));ring{2}.N=str2num(get(gui_handle.n2,'String'));ring{3}.N=str2num(get(gui_handle.n3,'String'));
         ring{1}.dist=str2num(get(gui_handle.d1,'String'));ring{2}.dist=str2num(get(gui_handle.d2,'String'));ring{3}.dist=str2num(get(gui_handle.d3,'String'));
         ring{1}.v=get(gui_handle.mat1,'Value');ring{2}.v=get(gui_handle.mat2,'Value');ring{3}.v=get(gui_handle.mat3,'Value');
         ring{1}.N_phase=str2num(get(gui_handle.phi1,'String'));ring{2}.N_phase=str2num(get(gui_handle.phi2,'String'));ring{3}.N_phase=str2num(get(gui_handle.phi3,'String'));
         ring{1}.angle=str2num(get(gui_handle.rot1,'String'));ring{2}.angle=str2num(get(gui_handle.rot2,'String'));ring{3}.angle=str2num(get(gui_handle.rot3,'String'));
         
function set_GUI(varargin)
   global  gui_handle data ring
         set(gui_handle.no_rings,'String',num2str(data.RN));
         set(gui_handle.type1,'String',num2str(ring{1}.type));set(gui_handle.type2,'String',num2str(ring{2}.type));set(gui_handle.type3,'String',num2str(ring{3}.type));
         set(gui_handle.k1,'String',num2str(ring{1}.k));set(gui_handle.k2,'String',num2str(ring{2}.k));set(gui_handle.k3,'String',num2str(ring{3}.k));
         set_radius('');
         set(gui_handle.n1,'String',num2str(ring{1}.N));set(gui_handle.n2,'String',num2str(ring{2}.N));set(gui_handle.n3,'String',num2str(ring{3}.N));
         set(gui_handle.d1,'String',num2str(ring{1}.dist));set(gui_handle.d2,'String',num2str(ring{2}.dist));set(gui_handle.d3,'String',num2str(ring{3}.dist));
         set(gui_handle.mat1,'Value',ring{1}.v);set(gui_handle.mat2,'Value',ring{2}.v);set(gui_handle.mat3,'Value',ring{3}.v);
         set(gui_handle.phi1,'String',num2str(ring{1}.N_phase));set(gui_handle.phi2,'String',num2str(ring{2}.N_phase));set(gui_handle.phi3,'String',num2str(ring{3}.N_phase));
         set(gui_handle.rot1,'String',num2str(ring{1}.angle));set(gui_handle.rot2,'String',num2str(ring{2}.angle));set(gui_handle.rot3,'String',num2str(ring{3}.angle));
%         magnet_tool_2D('no_rings');
         
function set_radius(varargin)
   global  gui_handle data ring
        set(gui_handle.ri1,'String',num2str(ring{1}.r(1)));set(gui_handle.rc1,'String',num2str(ring{1}.r(2)));set(gui_handle.ro1,'String',num2str(ring{1}.r(3)));set(gui_handle.ms1,'String',num2str(ring{1}.r(4)));
        set(gui_handle.ri2,'String',num2str(ring{2}.r(1)));set(gui_handle.rc2,'String',num2str(ring{2}.r(2)));set(gui_handle.ro2,'String',num2str(ring{2}.r(3)));set(gui_handle.ms2,'String',num2str(ring{2}.r(4)));
        set(gui_handle.ri3,'String',num2str(ring{3}.r(1)));set(gui_handle.rc3,'String',num2str(ring{3}.r(2)));set(gui_handle.ro3,'String',num2str(ring{3}.r(3)));set(gui_handle.ms3,'String',num2str(ring{3}.r(4)));

function get_radius(varargin)
   global  gui_handle data ring
         ring{1}.r=[str2num(get(gui_handle.ri1,'String')), str2num(get(gui_handle.rc1,'String')),str2num(get(gui_handle.ro1,'String')),str2num(get(gui_handle.ms1,'String'))];
         ring{2}.r=[str2num(get(gui_handle.ri2,'String')),str2num(get(gui_handle.rc2,'String')),str2num(get(gui_handle.ro2,'String')),str2num(get(gui_handle.ms2,'String'))];
         ring{3}.r=[str2num(get(gui_handle.ri3,'String')),str2num(get(gui_handle.rc3,'String')),str2num(get(gui_handle.ro3,'String')),str2num(get(gui_handle.ms3,'String'))];

function check_vis(varargin)
  global  gui_handle data ring
  switch data.RN
    case 1
    set(gui_handle.ring2,'Visible','Off');set(gui_handle.ring3,'Visible','Off');
    set(gui_handle.type2,'Visible','Off');set(gui_handle.type3,'Visible','Off');
    set(gui_handle.k2,'Visible','Off');set(gui_handle.k3,'Visible','Off');
    set(gui_handle.ri2,'Visible','Off');set(gui_handle.ri3,'Visible','Off');
    set(gui_handle.rc2,'Visible','Off');set(gui_handle.rc3,'Visible','Off');
    set(gui_handle.ro2,'Visible','Off');set(gui_handle.ro3,'Visible','Off');
    set(gui_handle.ms2,'Visible','Off');set(gui_handle.ms3,'Visible','Off');
    set(gui_handle.n2,'Visible','Off');set(gui_handle.n3,'Visible','Off');
    set(gui_handle.d2,'Visible','Off');set(gui_handle.d3,'Visible','Off');
    set(gui_handle.mat2,'Visible','Off');set(gui_handle.mat3,'Visible','Off');
    set(gui_handle.phi2,'Visible','Off');set(gui_handle.phi3,'Visible','Off');
    set(gui_handle.rot2,'Visible','Off');set(gui_handle.rot3,'Visible','Off');    
  case 2
    set(gui_handle.ring2,'Visible','On');set(gui_handle.ring3,'Visible','Off');
    set(gui_handle.type2,'Visible','On');set(gui_handle.type3,'Visible','Off');
    set(gui_handle.k2,'Visible','On');set(gui_handle.k3,'Visible','Off');
    set(gui_handle.ri2,'Visible','On');set(gui_handle.ri3,'Visible','Off');
    set(gui_handle.rc2,'Visible','On');set(gui_handle.rc3,'Visible','Off');
    set(gui_handle.ro2,'Visible','On');set(gui_handle.ro3,'Visible','Off');
    set(gui_handle.ms2,'Visible','On');set(gui_handle.ms3,'Visible','Off');
    set(gui_handle.n2,'Visible','On');set(gui_handle.n3,'Visible','Off');
    set(gui_handle.d2,'Visible','On');set(gui_handle.d3,'Visible','Off');
    set(gui_handle.mat2,'Visible','On');set(gui_handle.mat3,'Visible','Off');
    set(gui_handle.phi2,'Visible','On');set(gui_handle.phi3,'Visible','Off');
    set(gui_handle.rot2,'Visible','On');set(gui_handle.rot3,'Visible','Off');    
  otherwise
    set(gui_handle.ring2,'Visible','On');set(gui_handle.ring3,'Visible','On');
    set(gui_handle.type2,'Visible','On');set(gui_handle.type3,'Visible','On');
    set(gui_handle.k2,'Visible','On');set(gui_handle.k3,'Visible','On');
    set(gui_handle.ri2,'Visible','On');set(gui_handle.ri3,'Visible','On');
    set(gui_handle.rc2,'Visible','On');set(gui_handle.rc3,'Visible','On');
    set(gui_handle.ro2,'Visible','On');set(gui_handle.ro3,'Visible','On');
    set(gui_handle.ms2,'Visible','On');set(gui_handle.ms3,'Visible','On');
    set(gui_handle.n2,'Visible','On');set(gui_handle.n3,'Visible','On');
    set(gui_handle.d2,'Visible','On');set(gui_handle.d3,'Visible','On');
    set(gui_handle.mat2,'Visible','On');set(gui_handle.mat3,'Visible','On');
    set(gui_handle.phi2,'Visible','On');set(gui_handle.phi3,'Visible','On');
    set(gui_handle.rot2,'Visible','On');set(gui_handle.rot3,'Visible','On');        
  end   

         
         
function MAKEgui(varargin)
   global  gui_handle data ring
   %create figure
   sz=get(0,'ScreenSize');
   gui_handle.fig = figure('Units','pixel','Interruptible','off','Position',[10 sz(4)-580 1000 550],'Name','Mandhala 2D Tool','Tag','mainfig','MenuBar','none','Color',[0.83,0.81,0.78]);
   set(gui_handle.fig,'BusyAction','queue');
   gui_handle.copyr=uicontrol('Style','text','Units','pixel','Position',[670,5,186,14], 'FontSize',8,'FontWeight','normal','String','(c) 2007 P.Blmler, ICG-3 FZJ','Backgroundcolor',[0.83,0.81,0.78]);
   
   gui_handle.rtxt=uicontrol('Style','text','Units','pixel','Position',[390,518,180,30], 'FontSize',16,'FontWeight','bold','String','2D Mandhalas','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','center');
   gui_handle.rtxt=uicontrol('Style','text','Units','pixel','Position',[10,500,180,20], 'FontSize',11,'String','No. of rings:','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.no_rings=uicontrol('Style','edit','Units','pixel','Position',[90,500,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''no_rings'')','String','1');
   gui_handle.ring1=uicontrol('Style','text','Units','pixel','Position',[155,470,100,23], 'FontSize',12,'String','Ring 1','FontWeight','bold','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','center');
   gui_handle.ring2=uicontrol('Style','text','Units','pixel','Position',[255,470,100,23], 'FontSize',12,'String','Ring 2','FontWeight','bold','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','center','Visible','off');
   gui_handle.ring3=uicontrol('Style','text','Units','pixel','Position',[355,470,100,23], 'FontSize',12,'String','Ring 3','FontWeight','bold','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','center','Visible','off');
   gui_handle.typ_txt=uicontrol('Style','text','Units','pixel','Position',[10,450,180,20], 'FontSize',11,'String','Type:','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.typ_txt=uicontrol('Style','text','Units','pixel','Position',[10,437,180,18], 'FontSize',10,'String','0=tetragon, 1=polygon','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.type1=uicontrol('Style','edit','Units','pixel','Position',[190,440,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{1}.type));
   gui_handle.type2=uicontrol('Style','edit','Units','pixel','Position',[290,440,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{2}.type),'Visible','off');
   gui_handle.type3=uicontrol('Style','edit','Units','pixel','Position',[390,440,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{3}.type),'Visible','off');
   gui_handle.k_txt=uicontrol('Style','text','Units','pixel','Position',[10,410,180,20], 'FontSize',11,'String','Halbach k','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.k_txt=uicontrol('Style','text','Units','pixel','Position',[10,397,180,18], 'FontSize',10,'String','+1 = inner dipole','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.k1=uicontrol('Style','edit','Units','pixel','Position',[190,405,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{1}.k));
   gui_handle.k2=uicontrol('Style','edit','Units','pixel','Position',[290,405,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{2}.k),'Visible','off');
   gui_handle.k3=uicontrol('Style','edit','Units','pixel','Position',[390,405,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{3}.k),'Visible','off');
   gui_handle.ri_txt=uicontrol('Style','text','Units','pixel','Position',[10,365,180,20], 'FontSize',11,'String','inner radius','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.ri1=uicontrol('Style','edit','Units','pixel','Position',[180,365,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''ri1'')','String',num2str(ring{1}.r(1)));
   gui_handle.ri2=uicontrol('Style','edit','Units','pixel','Position',[280,365,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''ri2'')','String',num2str(ring{2}.r(1)),'Visible','off');
   gui_handle.ri3=uicontrol('Style','edit','Units','pixel','Position',[380,365,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''ri3'')','String',num2str(ring{3}.r(1)),'Visible','off');
   gui_handle.rc_txt=uicontrol('Style','text','Units','pixel','Position',[10,330,180,20], 'FontSize',11,'String','central radius','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.rc1=uicontrol('Style','edit','Units','pixel','Position',[180,330,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''rc1'')','String',num2str(ring{1}.r(2)));
   gui_handle.rc2=uicontrol('Style','edit','Units','pixel','Position',[280,330,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''rc2'')','String',num2str(ring{2}.r(2)),'Visible','off');
   gui_handle.rc3=uicontrol('Style','edit','Units','pixel','Position',[380,330,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''rc3'')','String',num2str(ring{3}.r(2)),'Visible','off');
   gui_handle.ro_txt=uicontrol('Style','text','Units','pixel','Position',[10,295,180,20], 'FontSize',11,'String','outer radius','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.ro1=uicontrol('Style','edit','Units','pixel','Position',[180,295,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''ro1'')','String',num2str(ring{1}.r(3)));
   gui_handle.ro2=uicontrol('Style','edit','Units','pixel','Position',[280,295,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''ro2'')','String',num2str(ring{2}.r(3)),'Visible','off');
   gui_handle.ro3=uicontrol('Style','edit','Units','pixel','Position',[380,295,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''ro3'')','String',num2str(ring{3}.r(3)),'Visible','off');
   gui_handle.ms_txt=uicontrol('Style','text','Units','pixel','Position',[10,260,180,20], 'FontSize',11,'String','half magnet size','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.ms1=uicontrol('Style','edit','Units','pixel','Position',[180,260,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''ms1'')','String',num2str(ring{1}.r(4)));
   gui_handle.ms2=uicontrol('Style','edit','Units','pixel','Position',[280,260,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''ms2'')','String',num2str(ring{2}.r(4)),'Visible','off');
   gui_handle.ms3=uicontrol('Style','edit','Units','pixel','Position',[380,260,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''ms3'')','String',num2str(ring{3}.r(4)),'Visible','off');
   gui_handle.n_txt=uicontrol('Style','text','Units','pixel','Position',[10,220,180,20], 'FontSize',11,'String','number of magnets','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.n1=uicontrol('Style','edit','Units','pixel','Position',[190,220,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{1}.N));
   gui_handle.n2=uicontrol('Style','edit','Units','pixel','Position',[290,220,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{2}.N),'Visible','off');
   gui_handle.n3=uicontrol('Style','edit','Units','pixel','Position',[390,220,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{3}.N),'Visible','off');
   gui_handle.dis_txt=uicontrol('Style','text','Units','pixel','Position',[10,185,180,20], 'FontSize',11,'String','distance betw. magnets','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.d1=uicontrol('Style','edit','Units','pixel','Position',[180,185,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{1}.dist));
   gui_handle.d2=uicontrol('Style','edit','Units','pixel','Position',[280,185,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{2}.dist),'Visible','off');
   gui_handle.d3=uicontrol('Style','edit','Units','pixel','Position',[380,185,50,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{3}.dist),'Visible','off');
   gui_handle.mat_txt=uicontrol('Style','text','Units','pixel','Position',[10,150,180,20], 'FontSize',11,'String','magnet material','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.mat1=uicontrol('Style','Popupmenu','Units','pixel','Position',[180 150 70 20],'Callback','magnet_tool_2D(''material'')',...
         'String',{'NdFeB31','NdFeB35','NdFeB38','NdFeB40','NdFeB44','NdFeB45','NdFeB48','NdFeB53','SmCo20','SmCo24','SmCo27','Sm2Co26','Sm2Co28'},'BackgroundColor',[0.83,0.81,0.78],'Value',7);
   gui_handle.mat2=uicontrol('Style','Popupmenu','Units','pixel','Position',[280 150 70 20],'Callback','magnet_tool_2D(''material'')',...
         'String',{'NdFeB31','NdFeB35','NdFeB38','NdFeB40','NdFeB44','NdFeB45','NdFeB48','NdFeB53','SmCo20','SmCo24','SmCo27','Sm2Co26','Sm2Co28'},'BackgroundColor',[0.83,0.81,0.78],'Value',7,'Visible','off');
   gui_handle.mat3=uicontrol('Style','Popupmenu','Units','pixel','Position',[380 150 70 20],'Callback','magnet_tool_2D(''material'')',...
         'String',{'NdFeB31','NdFeB35','NdFeB38','NdFeB40','NdFeB44','NdFeB45','NdFeB48','NdFeB53','SmCo20','SmCo24','SmCo27','Sm2Co26','Sm2Co28'},'BackgroundColor',[0.83,0.81,0.78],'Value',7,'Visible','off');
   gui_handle.phase_txt=uicontrol('Style','text','Units','pixel','Position',[10,95,180,20], 'FontSize',11,'String','phase []','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.phi1=uicontrol('Style','edit','Units','pixel','Position',[190,95,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{1}.N_phase));
   gui_handle.phi2=uicontrol('Style','edit','Units','pixel','Position',[290,95,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{2}.N_phase),'Visible','off');
   gui_handle.phi3=uicontrol('Style','edit','Units','pixel','Position',[390,95,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{3}.N_phase),'Visible','off');
   gui_handle.rot_txt=uicontrol('Style','text','Units','pixel','Position',[10,60,180,20], 'FontSize',11,'String','rotation []','Backgroundcolor',[0.83,0.81,0.78],'HorizontalAlignment','left');
   gui_handle.rot1=uicontrol('Style','edit','Units','pixel','Position',[190,60,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{1}.angle));
   gui_handle.rot2=uicontrol('Style','edit','Units','pixel','Position',[290,60,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{2}.angle),'Visible','off');
   gui_handle.rot3=uicontrol('Style','edit','Units','pixel','Position',[390,60,30,22],'BackgroundColor',[0.93,0.91,0.88],'Callback','magnet_tool_2D(''calc'')','String',num2str(ring{3}.angle),'Visible','off');
   gui_handle.sepw=uicontrol('Style','Pushbutton','Units','pixel','Position',[685,27,130,15],'Callback','magnet_tool_2D(''sep_win'')','Value',0,'String','seperate plot window','Visible','On','BackgroundColor',[0.83,0.81,0.78]);
  
   gui_handle.load_button=uicontrol('Style','Pushbutton','Units','pixel','Position',[10 10 122 30],'Callback','magnet_tool_2D(''load'')','BackgroundColor',[0.83,0.81,0.78],'FontSize',11,'FontWeight','bold','String','load');
   gui_handle.load_button=uicontrol('Style','Pushbutton','Units','pixel','Position',[140 10 122 30],'Callback','magnet_tool_2D(''save'')','BackgroundColor',[0.83,0.81,0.78],'FontSize',11,'FontWeight','bold','String','save');
   gui_handle.FEMM_button=uicontrol('Style','Pushbutton','Units','pixel','Position',[270 10 122 30],'Callback','magnet_tool_2D(''saveASCII'')','BackgroundColor',[0.83,0.81,0.78],'FontSize',11,'FontWeight','bold','String','export > ASCII');
   gui_handle.FEMM_button=uicontrol('Style','Pushbutton','Units','pixel','Position',[400 10 122 30],'Callback','magnet_tool_2D(''saveFEMM'')','BackgroundColor',[0.83,0.81,0.78],'FontSize',11,'FontWeight','bold','String','export > FEMM');

   gui_handle.exit_button=uicontrol('Style','Pushbutton','Units','pixel','Position',[870 10 122 30],'Callback','magnet_tool_2D(''bye'')','BackgroundColor',[0.83,0.81,0.78],'ForegroundColor',[1,0,0],'FontSize',11,'FontWeight','bold','String','EXIT');
