%############################################################################
%#
%#                          function mandhala_rot
%#
%#    rotates the 2D-GEOMETRY of single mandhala rings. 
%#    
%#   input: 
%#     ring = structure as produced by mandhala_2D
%#    angle = rotation angle [in degrees]
%#    
%#   output:
%#     ring = rotated structure
%#
%#      (c) P. Blmler 3/07
%############################################################################
%----------------------------------------------------------------------------
%  version 1.0 PB 26/3/07    (please change this when code is altered)
%----------------------------------------------------------------------------

function ring=mandhala_rot(ring,angle)
ring.angle=angle;
s=sin(angle*pi/180);
c=cos(angle*pi/180);
ring.m=ring.m-angle*pi/180;

for i=1:ring.N
  x=c*ring.c(i,1)+s*ring.c(i,2);
  y=-s*ring.c(i,1)+c*ring.c(i,2);
  ring.c(i,1)=x;
  ring.c(i,2)=y;
  for j=1:ring.n
    x=c*ring.p(i,j,1)+s*ring.p(i,j,2);
    y=-s*ring.p(i,j,1)+c*ring.p(i,j,2);
    ring.p(i,j,1)=x;
    ring.p(i,j,2)=y;
  end
end
