%############################################################################
%#
%#                          function mandhala_write_ASCII
%#
%#    creates ASCII file with one ring (append mode)
%#    
%#   input: 
%#     ring = structure as produced by mandhala_2D
%#     file = output filename
%#
%#      (c) P. Blmler 3/07
%############################################################################
%----------------------------------------------------------------------------
%  version 1.0 PB 26/3/07    (please change this when code is altered)
%----------------------------------------------------------------------------

function mandhala_write_ASCII(ring,filename)
RN=length(ring);
fid=fopen(filename,'w');
fprintf(fid,'2D Mandhala consisting of ',num2str(RN),' rings\n');
fprintf(fid,['generated at ',date,'\n']);
fprintf(fid,'_________________________________________________________\n');
fprintf(fid,' \n');

for i=1:RN
fprintf(fid,['RING #',num2str(i),'\n']);
if ring{i}.type==0
  fprintf(fid,[num2str(ring{i}.N),' magnets with 4 corners\n']);
else
  fprintf(fid,[num2str(ring{i}.N),' magnets with ',num2str(ring{i}.N/2),' corners\n']);
end
fprintf(fid,['number of magnets:',num2str(ring{i}.N),'\n']);
if ring{i}.type==0
   fprintf(fid,'number of corners: 4\n');
else
  fprintf(fid,['number of corners: ',num2str(ring{i}.N/2),'\n']);
end
fprintf(fid,['Halbach k: ',num2str(ring{i}.k),'\n']);
fprintf(fid,['material: ',ring{i}.mat,'\n']);
fprintf(fid,['remanence [T]: ',num2str(ring{i}.Br),'\n']);
fprintf(fid,['coercivity [A/m]: ',num2str(ring{i}.Hc),'\n']);
fprintf(fid,['permittivity: ',num2str(ring{i}.mu),'\n']);
fprintf(fid,['conductivity [MS/m]: ',num2str(ring{i}.sig),'\n']);
fprintf(fid,['inner radius: ',num2str(ring{i}.r(1)),'\n']);
fprintf(fid,['center radius: ',num2str(ring{i}.r(2)),'\n']);
fprintf(fid,['outer radius: ',num2str(ring{i}.r(3)),'\n']);
fprintf(fid,['magnet half size: ',num2str(ring{i}.r(4)),'\n']);
fprintf(fid,['distance between magnets: ',num2str(ring{i}.dist),'\n']);
fprintf(fid,['ring phase: ',num2str(ring{i}.N_phase),'\n']);
fprintf(fid,['ring rotation: ',num2str(ring{i}.angle),'\n']);
fprintf(fid,'_________________________________________________________\n');
fprintf(fid,' \n');
fprintf(fid,'MAGNET COORDINATES:\n');
fprintf(fid,'x/y=corner coordinates, xc/yc=center coordiantes, gamma = magnetization angle\n');
fprintf(fid,' \n');
fprintf(fid,'x\ty\txc\tyc\tgamma[]\n');
for j=1:ring{i}.N
  fprintf(fid,['magnet#',num2str(j),'\n']);
  for k=1:ring{i}.n
     str=[num2str(ring{i}.p(j,k,1),'%-6.3f'),'\t',num2str(ring{i}.p(j,k,2),'%-6.3f'),'\t',num2str(ring{i}.c(j,1),'%-6.3f'),'\t',num2str(ring{i}.c(j,2),'%-6.3f'),'\t',num2str(ring{i}.m(j),'%-6.3f'),'\n'];
     fprintf(fid,str);
  end
end
fprintf(fid,'_________________________________________________________\n');
fprintf(fid,' \n');

end
fclose(fid);